/// @cond EO_CXX_EO_IMPL

inline void elm::prefs::reset(Elm_Prefs_Reset_Mode mode_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_prefs_reset(mode_));
}

inline bool elm::prefs::item_value_set(::efl::eina::string_view name_, const Eina_Value * value_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_prefs_item_value_set(::efl::eolian::to_c(name_), value_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool elm::prefs::item_value_get(::efl::eina::string_view name_, Eina_Value* value_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_prefs_item_value_get(::efl::eolian::to_c(name_), value_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::evas::object elm::prefs::item_object_get(::efl::eina::string_view name_) const
{
   const Evas_Object * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_prefs_item_object_get(::efl::eolian::to_c(name_)));
   return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::prefs::item_disabled_set(::efl::eina::string_view name_, bool disabled_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_prefs_item_disabled_set(::efl::eolian::to_c(name_), ::efl::eolian::to_c(disabled_)));
}

inline bool elm::prefs::item_disabled_get(::efl::eina::string_view name_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_prefs_item_disabled_get(::efl::eolian::to_c(name_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool elm::prefs::item_swallow(::efl::eina::string_view name_, ::evas::object child_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_prefs_item_swallow(::efl::eolian::to_c(name_), ::efl::eolian::to_c(child_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::prefs::item_editable_set(::efl::eina::string_view name_, bool editable_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_prefs_item_editable_set(::efl::eolian::to_c(name_), ::efl::eolian::to_c(editable_)));
}

inline bool elm::prefs::item_editable_get(::efl::eina::string_view name_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_prefs_item_editable_get(::efl::eolian::to_c(name_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::evas::object elm::prefs::item_unswallow(::efl::eina::string_view name_) const
{
   Evas_Object * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_prefs_item_unswallow(::efl::eolian::to_c(name_)));
   return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::prefs::item_visible_set(::efl::eina::string_view name_, bool visible_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_prefs_item_visible_set(::efl::eolian::to_c(name_), ::efl::eolian::to_c(visible_)));
}

inline bool elm::prefs::item_visible_get(::efl::eina::string_view name_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_prefs_item_visible_get(::efl::eolian::to_c(name_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline Elm_Prefs_Data * elm::prefs::data_get() const
{
   Elm_Prefs_Data * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_prefs_data_get());
   return _tmp_ret;
}

inline bool elm::prefs::data_set(Elm_Prefs_Data * data_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_prefs_data_set(data_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool elm::prefs::autosave_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_prefs_autosave_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::prefs::autosave_set(bool autosave_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_prefs_autosave_set(::efl::eolian::to_c(autosave_)));
}

inline void eo_cxx::elm::prefs::reset(Elm_Prefs_Reset_Mode mode_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_prefs_reset(mode_));
}

inline bool eo_cxx::elm::prefs::item_value_set(::efl::eina::string_view name_, const Eina_Value * value_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_prefs_item_value_set(::efl::eolian::to_c(name_), value_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool eo_cxx::elm::prefs::item_value_get(::efl::eina::string_view name_, Eina_Value* value_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_prefs_item_value_get(::efl::eolian::to_c(name_), value_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::evas::object eo_cxx::elm::prefs::item_object_get(::efl::eina::string_view name_) const
{
   const Evas_Object * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_prefs_item_object_get(::efl::eolian::to_c(name_)));
   return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::prefs::item_disabled_set(::efl::eina::string_view name_, bool disabled_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_prefs_item_disabled_set(::efl::eolian::to_c(name_), ::efl::eolian::to_c(disabled_)));
}

inline bool eo_cxx::elm::prefs::item_disabled_get(::efl::eina::string_view name_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_prefs_item_disabled_get(::efl::eolian::to_c(name_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool eo_cxx::elm::prefs::item_swallow(::efl::eina::string_view name_, ::evas::object child_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_prefs_item_swallow(::efl::eolian::to_c(name_), ::efl::eolian::to_c(child_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::prefs::item_editable_set(::efl::eina::string_view name_, bool editable_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_prefs_item_editable_set(::efl::eolian::to_c(name_), ::efl::eolian::to_c(editable_)));
}

inline bool eo_cxx::elm::prefs::item_editable_get(::efl::eina::string_view name_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_prefs_item_editable_get(::efl::eolian::to_c(name_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::evas::object eo_cxx::elm::prefs::item_unswallow(::efl::eina::string_view name_) const
{
   Evas_Object * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_prefs_item_unswallow(::efl::eolian::to_c(name_)));
   return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::prefs::item_visible_set(::efl::eina::string_view name_, bool visible_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_prefs_item_visible_set(::efl::eolian::to_c(name_), ::efl::eolian::to_c(visible_)));
}

inline bool eo_cxx::elm::prefs::item_visible_get(::efl::eina::string_view name_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_prefs_item_visible_get(::efl::eolian::to_c(name_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline Elm_Prefs_Data * eo_cxx::elm::prefs::data_get() const
{
   Elm_Prefs_Data * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_prefs_data_get());
   return _tmp_ret;
}

inline bool eo_cxx::elm::prefs::data_set(Elm_Prefs_Data * data_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_prefs_data_set(data_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool eo_cxx::elm::prefs::autosave_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_prefs_autosave_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::prefs::autosave_set(bool autosave_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_prefs_autosave_set(::efl::eolian::to_c(autosave_)));
}

inline ::eo_cxx::elm::prefs::operator ::elm::prefs() const
{
   return *static_cast<::elm::prefs const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::prefs::operator ::elm::prefs&()
{
   return *static_cast<::elm::prefs*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::prefs::operator ::elm::prefs const&() const
{
   return *static_cast<::elm::prefs const*>(static_cast<void const*>(this));
}

template <typename T>
void elm_prefs_reset_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Prefs_Reset_Mode mode_)
{
   try
      {
         static_cast<T*>(self->this_)->reset(mode_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_prefs_item_value_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * name_, const Eina_Value * value_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_value_set(::efl::eolian::to_cxx<::efl::eina::string_view>(name_, std::tuple<std::false_type>()), value_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
bool elm_prefs_item_value_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * name_, Eina_Value* value_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_value_get(::efl::eolian::to_cxx<::efl::eina::string_view>(name_, std::tuple<std::false_type>()), value_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::evas::object elm_prefs_item_object_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * name_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_object_get(::efl::eolian::to_cxx<::efl::eina::string_view>(name_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const Evas_Object * _tmp_ret{};
         return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_prefs_item_disabled_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * name_, Eina_Bool disabled_)
{
   try
      {
         static_cast<T*>(self->this_)->item_disabled_set(::efl::eolian::to_cxx<::efl::eina::string_view>(name_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<bool>(disabled_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_prefs_item_disabled_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * name_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_disabled_get(::efl::eolian::to_cxx<::efl::eina::string_view>(name_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
bool elm_prefs_item_swallow_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * name_, Evas_Object * child_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_swallow(::efl::eolian::to_cxx<::efl::eina::string_view>(name_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::evas::object>(child_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_prefs_item_editable_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * name_, Eina_Bool editable_)
{
   try
      {
         static_cast<T*>(self->this_)->item_editable_set(::efl::eolian::to_cxx<::efl::eina::string_view>(name_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<bool>(editable_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_prefs_item_editable_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * name_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_editable_get(::efl::eolian::to_cxx<::efl::eina::string_view>(name_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::evas::object elm_prefs_item_unswallow_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * name_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_unswallow(::efl::eolian::to_cxx<::efl::eina::string_view>(name_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Evas_Object * _tmp_ret{};
         return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_prefs_item_visible_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * name_, Eina_Bool visible_)
{
   try
      {
         static_cast<T*>(self->this_)->item_visible_set(::efl::eolian::to_cxx<::efl::eina::string_view>(name_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<bool>(visible_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_prefs_item_visible_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * name_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_visible_get(::efl::eolian::to_cxx<::efl::eina::string_view>(name_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
Elm_Prefs_Data * elm_prefs_data_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->data_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Prefs_Data * _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
bool elm_prefs_data_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Prefs_Data * data_)
{
   try
      {
         return static_cast<T*>(self->this_)->data_set(data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
bool elm_prefs_autosave_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->autosave_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_prefs_autosave_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool autosave_)
{
   try
      {
         static_cast<T*>(self->this_)->autosave_set(::efl::eolian::to_cxx<bool>(autosave_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::prefs >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::widget >::template type<T>
         , virtual operations< ::efl::file >::template type<T>
   {
      virtual void reset(Elm_Prefs_Reset_Mode mode_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_prefs_reset(mode_));
      }

      virtual bool item_value_set(::efl::eina::string_view name_, const Eina_Value * value_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_prefs_item_value_set(::efl::eolian::to_c(name_), value_));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool item_value_get(::efl::eina::string_view name_, Eina_Value* value_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_prefs_item_value_get(::efl::eolian::to_c(name_), value_));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::evas::object item_object_get(::efl::eina::string_view name_)
      {
         const Evas_Object * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_prefs_item_object_get(::efl::eolian::to_c(name_)));
            return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void item_disabled_set(::efl::eina::string_view name_, bool disabled_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_prefs_item_disabled_set(::efl::eolian::to_c(name_), ::efl::eolian::to_c(disabled_)));
      }

      virtual bool item_disabled_get(::efl::eina::string_view name_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_prefs_item_disabled_get(::efl::eolian::to_c(name_)));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool item_swallow(::efl::eina::string_view name_, ::evas::object child_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_prefs_item_swallow(::efl::eolian::to_c(name_), ::efl::eolian::to_c(child_)));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void item_editable_set(::efl::eina::string_view name_, bool editable_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_prefs_item_editable_set(::efl::eolian::to_c(name_), ::efl::eolian::to_c(editable_)));
      }

      virtual bool item_editable_get(::efl::eina::string_view name_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_prefs_item_editable_get(::efl::eolian::to_c(name_)));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::evas::object item_unswallow(::efl::eina::string_view name_)
      {
         Evas_Object * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_prefs_item_unswallow(::efl::eolian::to_c(name_)));
            return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void item_visible_set(::efl::eina::string_view name_, bool visible_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_prefs_item_visible_set(::efl::eolian::to_c(name_), ::efl::eolian::to_c(visible_)));
      }

      virtual bool item_visible_get(::efl::eina::string_view name_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_prefs_item_visible_get(::efl::eolian::to_c(name_)));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual Elm_Prefs_Data * data_get()
      {
         Elm_Prefs_Data * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_prefs_data_get());
            return _tmp_ret;
      }

      virtual bool data_set(Elm_Prefs_Data * data_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_prefs_data_set(data_));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool autosave_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_prefs_autosave_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void autosave_set(bool autosave_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_prefs_autosave_set(::efl::eolian::to_c(autosave_)));
      }

   };
};


template<>
struct operation_description_class_size< ::elm::prefs >
{
   static constexpr int value = 
#if defined(PREFS_PROTECTED) && defined(PREFS_BETA)
      16
#elif defined(PREFS_PROTECTED)
      16
#elif defined(PREFS_BETA)
      16
#else
      16
#endif
      + operation_description_class_size<::elm::widget >::value      + operation_description_class_size<::efl::file >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::prefs>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_prefs_reset_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_prefs_reset);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_prefs_item_value_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_prefs_item_value_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_prefs_item_value_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_prefs_item_value_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_prefs_item_object_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_prefs_item_object_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_prefs_item_disabled_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_prefs_item_disabled_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_prefs_item_disabled_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_prefs_item_disabled_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_prefs_item_swallow_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_prefs_item_swallow);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_prefs_item_editable_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_prefs_item_editable_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_prefs_item_editable_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_prefs_item_editable_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_prefs_item_unswallow_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_prefs_item_unswallow);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_prefs_item_visible_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_prefs_item_visible_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_prefs_item_visible_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_prefs_item_visible_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_prefs_data_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_prefs_data_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_prefs_data_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_prefs_data_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_prefs_autosave_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_prefs_autosave_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_prefs_autosave_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_prefs_autosave_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::widget>(), &ops[operation_description_class_size< ::elm::prefs >::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::efl::file>(), &ops[operation_description_class_size< ::elm::prefs >::value + operation_description_class_size<::elm::widget>::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::prefs>)
{
   return (ELM_PREFS_CLASS);
}

} } }

/// @endcond

